﻿Imports System.IO
Imports System.Text.RegularExpressions

Public Class frmMain

    'Declare the variables
    Dim Entry As String
    Dim EntrySurname As String
    Dim Score As String
    Dim strSplit(5) As String
    Dim strDetails As String
    Dim strAllDetails(50, 5) As String
    Dim student As Integer



    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'Declare the text file and the mode
        Dim totalDetails As StreamReader = File.OpenText("studentdetails.txt")

        'Read from the text file into the list box
        Do While totalDetails.Peek <> -1

            'Get the current record into a string
            strDetails = totalDetails.ReadLine()

            'Add the current line to the listbox
            lstnames.Items.Add(strDetails)

            'Split the string back into individual strings
            strSplit = strDetails.Split(",")

            'Save details to the array
            For detail = 0 To 5
                strAllDetails(student, detail) = strSplit(detail)
            Next detail

            'Increment the student
            student += 1

        Loop

        'Close the text file
        totalDetails.Close()

    End Sub

    Private Sub btnremove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnremove.Click

        If lstnames.SelectedIndex <> -1 Then

            'Remove the currently selected record from the list
            lstnames.Items.Remove(lstnames.Text)
        Else

            'No record has been selected for deletion
            MsgBox("In order to delete a record, you must select a record")

        End If
        

    End Sub

    Private Sub btnadd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnadd.Click

        'Declare the local variable
        Dim FoundMatch As Boolean

        'Check whether email address is valid
        Try
            FoundMatch = Regex.IsMatch(txtemail.Text, "\A(?:[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?)\Z", RegexOptions.IgnoreCase)
        Catch ex As ArgumentException
        End Try

        If txtfirst.Text = "" Then
            MsgBox("Please enter a name")
        ElseIf txtlast.Text = "" Then
            MsgBox("Please enter a surname")
        ElseIf txtnumber.Text = "" Then
            MsgBox("Please enter a phone number")
        ElseIf cmbage.Text = "" Then
            MsgBox("Please select an age")
        ElseIf txtemail.Text = "" Then
            MsgBox("Please enter an email address")
        ElseIf Not FoundMatch Then
            MsgBox("Not a Valid Email Address")
        Else
            'Save the details as a complete string
            Entry = Now & ", " + txtlast.Text + " , " + txtfirst.Text + ", " + txtemail.Text + ", " + txtnumber.Text + ", " + cmbage.Text

            'Save the string to a text file
            lstnames.Items.Add(Entry)

            'Clear the contents of the controls
            txtfirst.Text = ""
            txtlast.Text = ""
            txtemail.Text = ""
            txtnumber.Text = ""
            cmbage.Text = ""

        End If

    End Sub

    Private Sub btnexit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnexit.Click

        'Make sure the text file is written to by date
        If btnSurname.Text = "Order by date" Then

            'Call the function order by surname
            orderbydate()

        End If

        'Declare the text file
        Dim details As StreamWriter = File.CreateText("studentdetails.txt")

        'Loop through the list and save all records to a text file
        For Each Name As Object In lstnames.Items
            details.WriteLine(Name)
        Next

        'Close the text file
        details.Close()

        'Exit the program
        End

    End Sub

    Private Sub btnedit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnedit.Click

        'Only allow editing when the list is ordered by date
        If btnSurname.Text = "Order by date" Then

            'You can't edit details when they're ordered by surname
            MsgBox("Please order by date to edit user details - Click the button Order by date")

        Else

            If lstnames.SelectedIndex <> -1 Then

                'Get the current record into a string
                strDetails = lstnames.Items(lstnames.SelectedIndex)

                'Remove the currently selected record from the list
                lstnames.Items.Remove(lstnames.Text)

                'Split the string back into individual strings
                strSplit = strDetails.Split(",")

                'Display the individual strings into their original controls
                txtfirst.Text = strSplit(2)
                txtlast.Text = strSplit(1)
                txtemail.Text = strSplit(3)
                txtnumber.Text = strSplit(4)
                cmbage.Text = strSplit(5)
            Else
                MsgBox("You need to select a record to edit")

            End If
        End If


    End Sub


    Private Sub txtnumber_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtnumber.KeyPress

        'Declare the variable
        Dim allowedChars As String = "0123456789$,"

        'Check whether they have entered a number, and disallow any other input
        If allowedChars.IndexOf(e.KeyChar) = -1 Then

            ' Invalid Character
            e.Handled = True

        End If

    End Sub

    Private Sub btnSurname_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSurname.Click

        If btnSurname.Text = "Order by surname" Then

            'Call the function order by surname
            orderbysurname()

            'Change the button
            btnSurname.Text = "Order by date"

        ElseIf btnSurname.Text = "Order by date" Then

            'Call the function order by surname
            orderbydate()

            'Change the button
            btnSurname.Text = "Order by surname"

        End If
        


    End Sub

    Function orderbysurname()

        'Clear the textbox
        lstnames.Items.Clear()

        'Read back in the 2D array without the date, which is at index 0
        For surname = 0 To student
            lstnames.Items.Add(strAllDetails(student, 1) & ", " & strAllDetails(student, 2) & ", " & strAllDetails(student, 3) & ", " & strAllDetails(student, 4) & ", " & strAllDetails(student, 5))
        Next surname

    End Function

    Function orderbydate()

        'Clear the listbox
        lstnames.Items.Clear()

        'Read the entire 2D array in, including the date
        For surname = 0 To student
            lstnames.Items.Add(strAllDetails(student, 0) & ", " & strAllDetails(student, 1) & ", " & strAllDetails(student, 2) & ", " & strAllDetails(student, 3) & ", " & strAllDetails(student, 4) & ", " & strAllDetails(student, 5))
        Next surname

    End Function

End Class
